<template>
  <v-card class="flex-grow-1 d-flex flex-column pa-4 pt-2" elevation="5">
    <v-card-title>
      <icon-with-text :icon="content.icon" size="small" class="justify-center">
        {{ $t(`home.${content.type}.${content.id}.name`) }}
      </icon-with-text>
    </v-card-title>
    <v-card-text class="mt-2">
      <hyphenated-justified-text>
        {{ $t(`home.${content.type}.${content.id}.description`) }}
      </hyphenated-justified-text>
    </v-card-text>
    <v-card-actions>
      <v-btn
        :href="content.target.startsWith('/') ? '' : content.target"
        :to="content.target.startsWith('/') ? content.target : ''"
        :target="content.target.startsWith('/') ? '' : '_blank'"
        :color="content.enabled ? 'primary' : 'kitblack'"
        width="100%"
        size="large"
        variant="elevated"
        :disabled="!content.enabled"
      >
        {{ content.enabled ? $t(`home.${content.type}.button.enabled`) : $t(`home.${content.type}.button.disabled`) }}
      </v-btn>
    </v-card-actions>
  </v-card>
</template>

<script lang="ts">
import { defineComponent, PropType } from "vue";
import IconWithText from "@/components/IconWithText.vue";
import HyphenatedJustifiedText from "@/components/HyphenatedJustifiedText.vue";

export enum FunctionCardTypes {
  Identification = "identification",
  RequestCertificates = "certificates.request",
  ManageCertificates = "certificates.manage",
}

export type FunctionCardType = {
  type: FunctionCardTypes;
  id: string;
  icon: string;
  target: string;
  enabled: boolean;
};

export default defineComponent({
  components: { HyphenatedJustifiedText, IconWithText },
  props: {
    content: {
      type: Object as PropType<FunctionCardType>,
      required: true,
    },
  },
});
</script>
